//Copyright 2018 rat de combat sur forum.hardware.fr

/*
This file is part of the firmware for the AD9833-poor men's signal generator.

The firmware is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The firmware is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the firmware.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __AD9833_H__
#define __AD9833_H__
#include <stdint.h>

#define FSYNC PB2
#define SS PB2
#define MOSI PB3
#define MISO PB4
#define SCK PB5

typedef enum
{
	SINE,
	TRIANGLE,
	SQUARE,
	SQUARE_2
} waveform_t; 

typedef enum
{
	FREQ,
	PHASE
} reg_type_t;

typedef enum
{
	REG0,
	REG1
} reg_t;

void reset_ad9833(void);
void write_freq(const uint32_t f, const reg_t reg);
void write_phase(const uint16_t p, const reg_t reg); //phase in degrees
void write_waveform(const waveform_t w);
void select_register(const reg_type_t t, const reg_t reg);
#endif
